CREATE OR REPLACE TRIGGER USR_EXCLUSAO_IMPORTAAF
AFTER DELETE ON AUTOFORNE FOR EACH ROW
DECLARE
   V_DTGRV         DATE;
   V_HRGRV         VARCHAR2(04);

   V_NOVOCODIGO    INTEGER;
   V_FILIAL        VARCHAR2(10);
   V_MAIORCOD      INTEGER;
BEGIN
   V_MAIORCOD := 0;

   /* Retorna data e hora de exportao */
   BEGIN
      SELECT TO_DATE(SYSDATE), TO_CHAR(SYSDATE,'HH24MI')
        INTO V_DTGRV, V_HRGRV
        FROM DUAL;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_DTGRV := NULL;
         V_HRGRV := NULL;
   END;

   SELECT MAX(CDGRUPFILI)
     INTO V_FILIAL
     FROM FILGRUPFILI
    WHERE CDFILIAL = :OLD.CDFILLANC
      AND USR_IDPROTHEUS = 'S';

   IF NOT V_FILIAL IS NULL THEN
      /* Retorna o sequencial para a tabela */
      BEGIN
         SELECT W4_IDAFPCC.NEXTVAL
           INTO V_NOVOCODIGO
           FROM DUAL;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_NOVOCODIGO := 1;
      END;

      SELECT MAX(W4_IDAFPCC)
      INTO V_MAIORCOD
      FROM USR_ZW4
      WHERE CDFILDEST = :OLD.CDFILDEST
        AND CDFILLANC = :OLD.CDFILLANC
        AND NRAUTOFORN = :OLD.NRAUTOFORN;

      FOR C_USR_ZW4 IN (
         SELECT W4_EMPRESA, W4_FILIAL, W4_NUM, W4_EMISSAO, W4_CGC,
                W4_CONTATO, W4_MOEDA, W4_COND,
                W4_FILENT, W4_FRETE, W4_DESPESA, W4_SEGURO,
                W4_DESC1, W4_DESC2, W4_DESC3, W4_VLDESC,
                W4_TPFRETE, W4_VLTODN
           FROM USR_ZW4
          WHERE CDFILDEST = :OLD.CDFILDEST
            AND CDFILLANC = :OLD.CDFILLANC
            AND NRAUTOFORN = :OLD.NRAUTOFORN
            AND W4_IDAFPCC = V_MAIORCOD) LOOP

         INSERT INTO USR_ZW4
             (CDFILDEST, CDFILLANC, NRAUTOFORN,
              W4_IDAFPCC, W4_EMPRESA, W4_FILIAL, W4_NUM,
              W4_EMISSAO, W4_CGC, W4_CONTATO, W4_MOEDA, W4_COND,
              W4_FILENT, W4_FRETE, W4_DESPESA, W4_SEGURO,
              W4_DESC1, W4_DESC2, W4_DESC3, W4_VLDESC,
              W4_TPFRETE, W4_VLTODN, W4_TPEDI, W4_DTGRV,
              W4_HRGRV, W4_DTIMP, W4_HRIMP)
         VALUES
             (:OLD.CDFILDEST, :OLD.CDFILLANC, :OLD.NRAUTOFORN,
              V_NOVOCODIGO, C_USR_ZW4.W4_EMPRESA, C_USR_ZW4.W4_FILIAL, C_USR_ZW4.W4_NUM,
              C_USR_ZW4.W4_EMISSAO, C_USR_ZW4.W4_CGC,
              C_USR_ZW4.W4_CONTATO, C_USR_ZW4.W4_MOEDA, C_USR_ZW4.W4_COND,
              C_USR_ZW4.W4_FILENT, C_USR_ZW4.W4_FRETE, C_USR_ZW4.W4_DESPESA, C_USR_ZW4.W4_SEGURO,
              C_USR_ZW4.W4_DESC1, C_USR_ZW4.W4_DESC2, C_USR_ZW4.W4_DESC3, C_USR_ZW4.W4_VLDESC,
              C_USR_ZW4.W4_TPFRETE, C_USR_ZW4.W4_VLTODN, '2', V_DTGRV,
              V_HRGRV, NULL, '');
      END LOOP;

      FOR C_USR_ZW5 IN (
         SELECT CDFILDEST, CDFILLANC, NRAUTOFORN, CDMARCA, CDPRODUTO, DTPROGENTAF,
                W5_EMPRESA, W5_FILIAL, W5_NUM,
                W5_CGC, W5_ITEM, W5_PRODUTO, W5_DESCRI,
                W5_QUANT, W5_QTDSOL, W5_PRECO, W5_TOTAL,
                W5_IPI, W5_DATPRF, W5_LOCAL, W5_LOCENT,
                W5_OBS, W5_CC
           FROM USR_ZW5
          WHERE CDFILDEST = :OLD.CDFILDEST
            AND CDFILLANC = :OLD.CDFILLANC
            AND NRAUTOFORN = :OLD.NRAUTOFORN
            AND W5_IDAFPCI = V_MAIORCOD) LOOP

         INSERT INTO USR_ZW5
             (CDFILDEST, CDFILLANC, NRAUTOFORN, CDMARCA, CDPRODUTO, DTPROGENTAF,
              W5_IDAFPCI, W5_EMPRESA, W5_FILIAL, W5_NUM,
              W5_CGC, W5_ITEM, W5_PRODUTO, W5_DESCRI,
              W5_QUANT, W5_QTDSOL, W5_PRECO, W5_TOTAL,
              W5_IPI, W5_DATPRF, W5_LOCAL, W5_LOCENT,
              W5_OBS, W5_CC, W5_TPEDI, W5_DTGRV, W5_HRGRV,
              W5_DTIMP, W5_HRIMP)
         VALUES
            (C_USR_ZW5.CDFILDEST, C_USR_ZW5.CDFILLANC, C_USR_ZW5.NRAUTOFORN, C_USR_ZW5.CDMARCA, C_USR_ZW5.CDPRODUTO, C_USR_ZW5.DTPROGENTAF,
             V_NOVOCODIGO, C_USR_ZW5.W5_EMPRESA, C_USR_ZW5.W5_FILIAL, C_USR_ZW5.W5_NUM,
             C_USR_ZW5.W5_CGC, C_USR_ZW5.W5_ITEM, C_USR_ZW5.W5_PRODUTO, C_USR_ZW5.W5_DESCRI,
             C_USR_ZW5.W5_QUANT, C_USR_ZW5.W5_QTDSOL, C_USR_ZW5.W5_PRECO, C_USR_ZW5.W5_TOTAL,
             C_USR_ZW5.W5_IPI, C_USR_ZW5.W5_DATPRF, C_USR_ZW5.W5_LOCAL, C_USR_ZW5.W5_LOCENT,
             C_USR_ZW5.W5_OBS, C_USR_ZW5.W5_CC, '2', V_DTGRV,
             V_HRGRV, NULL, '');
      END LOOP;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_EXCLUSAO_IMPORTAAF','5.09.000'); END;
/
