/*
 TECNISA - TECNOLOGIA EM INFORMTICA

 NOME: IMPOSTO_TITEM_PEDIDO

 DESCRIO:
  PROCEDIMENTO PARA ATUALIZAO DOS IMPOSTOS DE TODOS OS ITENS DO PEDIDO


 RAISERROR('', 16,1);

 @C:\Win_605\Sql\End_Conv\SqlServer\5873_PEDFUNS_IMPOSTO_TITEM_PEDIDO.sql
*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'IMPOSTO_TITEM_PEDIDO'  and
            type = 'P'                  and
            u.uid = o.uid               and
            u.name = USER)
  DROP PROCEDURE IMPOSTO_TITEM_PEDIDO
  GO

CREATE PROCEDURE IMPOSTO_TITEM_PEDIDO @P_FILIAL     VARCHAR(4),
                                      @P_NRPEDIDO   VARCHAR(10)

AS
   DECLARE @V_CDEMPRESA         VARCHAR(02);
   DECLARE @V_CDINSCESTA        VARCHAR(16);
   DECLARE @V_CDTIPOOPER        VARCHAR(02);
   DECLARE @V_IDORIGDESTOP      VARCHAR(01);
   DECLARE @V_CDCLIENTE         VARCHAR(21);
   DECLARE @V_CDFILIALPED       VARCHAR(04);

   DECLARE @V_ITENS_CDFILIAL     VARCHAR(04);
   DECLARE @V_ITENS_NRPEDIDO     VARCHAR(10);
   DECLARE @V_ITENS_NRITEMPED    VARCHAR(10);
   DECLARE @V_ITENS_DTENTITPED   DATETIME;
   DECLARE @V_ITENS_CDCLIENTE    VARCHAR(21);
   DECLARE @V_ITENS_CDFILIALPED  VARCHAR(04);
   DECLARE @V_ITENS_CDTIPOOPER   VARCHAR(02);
   DECLARE @V_ITENS_IDORIGDESTOP VARCHAR(01);
   DECLARE @V_ITENS_CDEMPRESA    VARCHAR(02);
   DECLARE @V_ITENS_CDINSCESTA   VARCHAR(16);
   DECLARE @V_ITENS_QTITEMPED    DOUBLE PRECISION;
   DECLARE @V_ITENS_VRPREUNITPED DOUBLE PRECISION;
   DECLARE @V_ITENS_VRDESITPED   DOUBLE PRECISION;
   DECLARE @V_ITENS_CDPRODUTO    VARCHAR(10);
   DECLARE @V_ITENS_CDARVPROD    VARCHAR(20);

BEGIN
   SELECT @V_CDEMPRESA = MAX(F.CDEMPRESA), @V_CDINSCESTA = MAX(F.CDINSCESTA), @V_CDTIPOOPER = MAX(P.CDTIPOOPER), @V_IDORIGDESTOP = ISNULL(MAX(T.IDORIGDESTOP), 'C'),
          @V_CDCLIENTE = MAX(P.CDCLIENTE), @V_CDFILIALPED = MAX(P.CDFILIALPED)
     FROM PEDIDO P, TIPOOPERAC T, FILIAL F
    WHERE P.CDFILIAL = @P_FILIAL
      AND P.NRPEDIDO = @P_NRPEDIDO
      AND P.CDTIPOOPER = T.CDTIPOOPER
      AND P.IDENTRSAIDOP = T.IDENTRSAIDOP
      AND P.CDFILIAL = F.CDFILIAL;

   DECLARE C_ITENS CURSOR FOR SELECT P.CDFILIAL,  P.NRPEDIDO, I.NRITEMPED, I.DTENTITPED,
                                     P.CDCLIENTE, P.CDFILIALPED, P.CDTIPOOPER, ISNULL(T.IDORIGDESTOP, 'C'),
                                     F.CDEMPRESA, F.CDINSCESTA, I.QTITEMPED, I.VRPREUNITPED, I.VRDESITPED,
                                     I.CDPRODUTO, PR.CDARVPROD
                                FROM PEDIDO P, ITEMPEDIDO I, TIPOOPERAC T, FILIAL F, PRODUTO PR
                               WHERE P.CDFILIAL = @P_FILIAL
                                 AND P.NRPEDIDO = @P_NRPEDIDO
                                 AND P.CDFILIAL = I.CDFILIAL
                                 AND P.NRPEDIDO = I.NRPEDIDO
                                 AND P.CDTIPOOPER = T.CDTIPOOPER
                                 AND P.IDENTRSAIDOP = T.IDENTRSAIDOP
                                 AND P.CDFILIAL = F.CDFILIAL
                                 AND I.CDPRODUTO = PR.CDPRODUTO;
   OPEN C_ITENS;

   FETCH NEXT FROM C_ITENS INTO @V_ITENS_CDFILIAL,  @V_ITENS_NRPEDIDO, @V_ITENS_NRITEMPED, @V_ITENS_DTENTITPED,
                                @V_ITENS_CDCLIENTE, @V_ITENS_CDFILIALPED, @V_ITENS_CDTIPOOPER, @V_ITENS_IDORIGDESTOP,
                                @V_ITENS_CDEMPRESA, @V_ITENS_CDINSCESTA, @V_ITENS_QTITEMPED, @V_ITENS_VRPREUNITPED, @V_ITENS_VRDESITPED,
                                @V_ITENS_CDPRODUTO, @V_ITENS_CDARVPROD;

   WHILE (@@FETCH_STATUS = 0)
   BEGIN


      EXEC IMPOSTO_ITEMPEDIDO @V_ITENS_CDEMPRESA, @V_ITENS_CDINSCESTA, @V_ITENS_CDCLIENTE, @V_ITENS_CDFILIALPED,
                              @V_ITENS_CDFILIAL, @V_ITENS_NRPEDIDO, @V_ITENS_NRITEMPED, @V_ITENS_DTENTITPED,
                              @V_ITENS_CDTIPOOPER, @V_ITENS_IDORIGDESTOP;

      FETCH NEXT FROM C_ITENS INTO @V_ITENS_CDFILIAL,  @V_ITENS_NRPEDIDO, @V_ITENS_NRITEMPED, @V_ITENS_DTENTITPED,
                                   @V_ITENS_CDCLIENTE, @V_ITENS_CDFILIALPED, @V_ITENS_CDTIPOOPER, @V_ITENS_IDORIGDESTOP,
                                   @V_ITENS_CDEMPRESA, @V_ITENS_CDINSCESTA, @V_ITENS_QTITEMPED, @V_ITENS_VRPREUNITPED, @V_ITENS_VRDESITPED,
                                   @V_ITENS_CDPRODUTO, @V_ITENS_CDARVPROD;

   END;

   CLOSE C_ITENS;
   DEALLOCATE C_ITENS;

   EXEC IMPOSTO_PEDIDO @P_FILIAL, @P_NRPEDIDO;

END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'IMPOSTO_TITEM_PEDIDO','6.05.xxx';
GO